<?php
namespace Teknisa\MYM\Services;

use Zeedhi\Framework\DataSource\FilterCriteria;

class Mym00110InformativoService {

	protected $connection;
	protected $environment;
	protected $customerID;
	
	public function __construct($connection, $environment, $customerID){
        $this->connection = $connection;
        $this->environment = $environment;
        $this->customerID = $customerID;
	}

    public function getTopicNamesToPush($CDFILIAL, $NRLOCALPESQ){
        
        $query = "SELECT NRQRCODELOCALPESQ FROM QRCODELOCALPESQ WHERE CDFILIAL = :CDFILIAL AND (NRLOCALPESQ = :NRLOCALPESQ OR :NRLOCALPESQ IS NULL) AND SYSDATE <= NVL(DTEXPIRACAO,SYSDATE)";
        $stmt = $this->connection->prepare($query);
        $params = array(
            "CDFILIAL" => $CDFILIAL,
            "NRLOCALPESQ" => $NRLOCALPESQ
        );
        $stmt->execute($params);
        $qrCodeIDS = $stmt->fetchAll();

        $this->NRORG = $this->environment->getNrOrg();
        
        $concatNrorgAndCustomerID = function($sqlResultRow){
            return $this->customerID . "_" . $this->NRORG . "_" . $sqlResultRow['NRQRCODELOCALPESQ'];
        };
        
        return array_map($concatNrorgAndCustomerID, $qrCodeIDS);
    }
    
    public function getDatasExpiradasToPush($CDFILIAL, $NRLOCALPESQ){
        
        $query = "SELECT qr.nrqrcodelocalpesq, TO_CHAR(qr.dtexpiracao, 'DD/MM/YYYY') AS dtexpiracao, qr.cdfilial,  f.nmfilial, l.nmlocalpesq FROM qrcodelocalpesq qr INNER JOIN filial f on f.nrorg = qr.nrorg AND f.cdfilial = qr.cdfilial LEFT JOIN localpesq l ON l.nrorg = qr.nrorg AND l.nrlocalpesq = qr.nrlocalpesq WHERE qr.cdfilial =:cdfilial AND (qr.nrlocalpesq =:nrlocalpesq OR :nrlocalpesq IS NULL) AND SYSDATE > qr.dtexpiracao ORDER BY qr.cdfilial, l.nmlocalpesq";
        $stmt = $this->connection->prepare($query);
        $params = array(
            "CDFILIAL" => $CDFILIAL,
            "NRLOCALPESQ" => $NRLOCALPESQ
        );
        $stmt->execute($params);
        $qrCodeIDS = $stmt->fetchAll();

        $this->NRORG = $this->environment->getNrOrg();
        
        $concatString = function($sqlResultRow){
            
            return $sqlResultRow['DTEXPIRACAO'] . "_" . $sqlResultRow['NRQRCODELOCALPESQ'];
        };
        
        return $qrCodeIDS; 
    }

}